IncludeFile "INCLUDE\CoolFonts.pb"

Global CurrentRow, MaxRow, CurrentSpeed, BoxColor

Dim InstrumentArray(51,47)

#MOUSE = 2
#SCREENX = 800
#SCREENY = 600

Procedure MakeSprites()
   CatchSprite(#MOUSE,?MouseSprite)
   CreateSprite(0,10,10)
   StartDrawing(SpriteOutput(0))
     Circle(5,5,5,$050505)
   StopDrawing()
   CreateSprite(1,10,10)
   StartDrawing(SpriteOutput(1))
     Circle(5,5,6,$FFFFFF)  ; White
   StopDrawing()
EndProcedure

Procedure PlayItOnce(value)
   PlayNote(#Channel10,35+value)
   Delay(CurrentSpeed)
   StopNote(#Channel10,35+value)
EndProcedure

Procedure PlayTimer()
   For y = 0 To 46
      If InstrumentArray(CurrentRow,y)
         StopNote(#Channel10,35+y)
      EndIf
   Next y
   If CurrentRow = MaxRow : CurrentRow = -1 : EndIf
   CurrentRow + 1
   For y = 0 To 46
      If InstrumentArray(CurrentRow,y)
         PlayNote(#Channel10,35+y)
      EndIf
   Next y
EndProcedure

Procedure Main()
   If InitSprite() = 0 Or InitKeyboard() = 0 Or InitMouse() = 0
     MessageRequester("ERROR","Cant initialize DirectX!",#MB_ICONERROR) : Goto ENDAPP
   EndIf
   If OpenScreen(#SCREENX,#SCREENY,32,"PureMIDI Sequenzer") = 0
     If OpenScreen(#SCREENX,#SCREENY,24,"PureMIDI Sequenzer") = 0
       If OpenScreen(#SCREENX,#SCREENY,16,"PureMIDI Sequenzer") = 0
         MessageRequester("ERROR","Cant open DirectX screen!",#MB_ICONERROR) : Goto ENDAPP
   EndIf:EndIf:EndIf

   SetFrameRate(25)

   MakeSprites()   
   InstrumentsFont = CreateFont("Courier",8,#FONT_NORMAL)
   MIDIpainter     = CreateFont("Comic Sans MS",72,#FONT_ITALIC|#FONT_BOLD)
   Buttons         = CreateFont("Arial",24,#FONT_BOLD)

   isPlaying = 0
   CurrentSpeed = 100
   MaxRow = 50

   Repeat
     FlipBuffers()
     ExamineKeyboard()
     If IsScreenActive()
        ClearScreen($D0,$67,$14)

        StartDrawing(ScreenOutput())
          Restore InstrumentNames
          For a = 0 To 46
            Read A$
            DrawingMode(1)
            DrawingFont(InstrumentsFont)
            Locate(5,10+a*11)
            If y = a
              FrontColor($FF,$FF,$00)
              DrawText(A$)
              FrontColor($00,$00,$00)
            Else
              ;FrontColor(0,0,0)
              DrawText(A$)
            EndIf
          Next a

          FrontColor(0,0,0)
          DrawingFont(MIDIpainter)
          Locate(20,525)
          DrawText("PureBasic MIDI Painter")

          DrawingFont(Buttons)
          Locate(680,560)
          DrawText("Speed:"+Str(CurrentSpeed))

          Locate(720,535)
          If MouseOverNewButton
             FrontColor($2A,$5E,$D5)
          EndIf
          DrawText("New")
          
          If MouseOverPlayButton
             FrontColor($2A,$5E,$D5)
          ElseIf isPlaying
             FrontColor($FF,$FF,$FF)
          Else
             FrontColor($00,$00,$00)
          EndIf
          Locate(660,535)
          DrawText("Play")
          
          FrontColor($B6,$51,$22)
          Box(170,10,620,521)
          FrontColor($D0,$67,$14)
          Line(170, 10,4,0) : Line(170,11,2,0) : Line(170, 10,0,4)
          Line(786, 10,4,0) : Line(788,11,2,0) : Line(789, 10,0,4)
          Line(170,530,4,0) : Line(170,529,2,0): Line(170,526,0,4)
          Line(786,530,4,0) : Line(788,529,2,0): Line(789,526,0,4)
          If x => 0
             Box(177+x*12,15,6,511,$FFFF)
          EndIf

          If isPlaying
             Box(177+CurrentRow*12,2,6,6,$FFFFFF)
          Else
             Box(177+CurrentRow*12,2,6,6,$000000)
          EndIf
          Box(185+MaxRow*12,0,3,10,$646464)
          Box(188+MaxRow*12,0,3,10,$AAAAAA)

        StopDrawing()

        For y = 0 To 46
          For x = 0 To 50
            DisplayTransparentSprite(InstrumentArray(x,y),175+x*12,12+y*11)
          Next x
        Next y

        DisplayTransparentSprite(#MOUSE,MouseX,MouseY)

        ExamineMouse()
        MouseX = MouseX() : MouseY = MouseY()
        MouseOverPlayButton = 0
        MouseOverNewButton  = 0

        If MouseY < 12+47*11
          y = (MouseY-12)/11
          If MouseX > 175 And MouseX < 175+51*12
            x = (MouseX-175)/12
            If MouseY > 12
              If (x <> oldX Or y <> oldY Or MouseButtonTime = 0) And MouseButton(1)
                InstrumentArray(x,y) = InstrumentArray(x,y)!1
                oldX = x
                oldY = y
                MouseButtonTime = 20
              EndIf
            Else
              If MouseButton(1)
                 If x <= MaxRow
                    CurrentRow = x
                 EndIf
              ElseIf MouseButton(2)
                 MaxRow = x
                 If CurrentRow > MaxRow
                    CurrentRow = MaxRow
                 EndIf
              EndIf
              x = -1
              y = -1
            EndIf
          Else
            If MouseX < 170 And MouseY > 12
               x = (MouseX-175)/12
               If MouseButton(1) And MouseButtonTime = 0
                  WaitThread(PlayThread)
                  PlayThread = CreateThread(@PlayItOnce(),y)
                  MouseButtonTime = 10
               EndIf
            Else
              y = -1
            EndIf
            x = -1
          EndIf
        Else
          y = -1
          x = -1
          If MouseY > 533 And MouseY < 560
            If MouseX > 660 And MouseX < 700 And MouseButtonTime = 0
               MouseOverPlayButton = 1
               If MouseButton(1)
                  isPlaying ! 1
                  EndTimer(1)
                  If isPlaying
                     Select Speed
                        Case 1  : CurrentSpeed = 1
                        Default : CurrentSpeed = 100
                     EndSelect
                     StartTimer(1,CurrentSpeed,@PlayTimer())
                  EndIf
                  MouseButtonTime = 20
               EndIf
            ElseIf MouseX > 720 And MouseX < 760
               MouseOverNewButton = 1
               If MouseButton(1)
                 For a = 0 To 46
                   For b = 0 To 50
                     InstrumentArray(b,a) = 0
                   Next b
                 Next a
               EndIf
            EndIf
          EndIf
        EndIf
        If MouseButtonTime
           MouseButtonTime - 1
        EndIf
        
        If KeyboardPushed(#PB_Key_Escape)
           Quit = 1
        EndIf

     Else
       Delay(10)
     EndIf
   
   Until Quit = 1

   ; Cleanup
   DeleteFont(InstrumentsFont)
   DeleteFont(MIDIpainter)
   DeleteFont(Buttons)

EndProcedure

DataSection
  MouseSprite:
    IncludeBinary "INCLUDE\Mouse.bmp"
  InstrumentNames:
    Data.s "Acoustic Bass Drum", "Bass Drum 1"     , "Side Stick"          ; 01 - 03
    Data.s "Acoustic Snare"    , "Hand Clap"       , "Electric Snare"      ; 04 - 06
    Data.s "Low Floor Tom"     , "Closed High Hat" , "High Floor Tom"      ; 07 - 09
    Data.s "Pedal High Hat"    , "Low Tom"         , "Open High Hat"       ; 10 - 12
    Data.s "Low-Mid Tom"       , "High-Mid Tom"    , "Crash Cymbal 1"      ; 13 - 15
    Data.s "High Tom"          , "Ride Cymbal 1"   , "Chinese Cymbal"      ; 16 - 18
    Data.s "Ride Bell"         , "Tambourine"      , "Splash Cymbal"       ; 19 - 21
    Data.s "Cowbell"           , "Crash Cymbal 2"  , "Vibraslap"           ; 22 - 24
    Data.s "Ride Cymbal 2"     , "High Bongo"      , "Low Bongo"           ; 25 - 27
    Data.s "Mute High Conga"   , "Open High Conga" , "Low Conga"           ; 28 - 30
    Data.s "High Timbale"      , "Low Timbale"     , "High Agogo"          ; 31 - 33
    Data.s "Low Agogo"         , "Cabasa"          , "Maracas"             ; 34 - 36
    Data.s "Short Whistle"     , "Long Whistle"    , "Short Guiro"         ; 37 - 39
    Data.s "Long Guiro"        , "Claves"          , "High Wood Block"     ; 40 - 42
    Data.s "Low Wood Block"    , "Mute Cuica"      , "Open Cuica"          ; 43 - 45
    Data.s "Mute Triangle"     , "Open Triangle"                           ; 46 - 47
EndDataSection
; ExecutableFormat=
; DisableDebugger
; EOF